The chart legend supports the following customization:
Visible: the legend visibility.
Position: top, right, left, bottom, topRight.
Background: color, transparency.
Text: font family, font size, color.
Border: color, transparency, width.
Overlapping: whether the legend display with overlapping plotArea.
Layout: x, y, width, height.
You can customize the legend using the following code:
var spread;
window.onload = function () {
spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 });
initSpread(spread);
initEvent(spread);
//readSetting(new GC.Spread.Sheets.CellTypes.CheckBoxList());
}
function initSpread(spread) {
var sheet = spread.getSheet(0);
sheet.suspendPaint();
var dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
var chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 30, 120, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({text: "Chart Legend"});
var legend = chart.legend();
legend.borderStyle.color = "green";
legend.borderStyle.width = 3;
legend.fontSize = 9;
legend.backColor = "orange";
legend.backColorTransparency = 0.8;
chart.legend(legend);
sheet.resumePaint();
}
function initEvent(spread) {
spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
var sheet = spread.getActiveSheet();
var chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
_getElementById("apply").addEventListener('click', function () {
applySetting();
});
}
function readSetting(chart) {
var legend = chart.legend();
_getElementById("visible").checked = legend.visible;
_getElementById("position").value = legend.position;
_getElementById("backColor").value = legend.backColor;
_getElementById("backColorTransparency").value = legend.backColorTransparency;
_getElementById("color").value = legend.color;
_getElementById("fontFamily").value = legend.fontFamily;
_getElementById("fontSize").value = legend.fontSize;
_getElementById("border-color").value = legend.borderStyle.color;
_getElementById("border-width").value = legend.borderStyle.width;
_getElementById("border-transparency").value = legend.borderStyle.transparency;
_getElementById("showLegendWithoutOverlapping").checked = legend.showLegendWithoutOverlapping !== false;
if (legend.layout && legend.layout.x) {
_getElementById("layoutX").value = legend.layout.x;
}
if (legend.layout && legend.layout.y) {
_getElementById("layoutY").value = legend.layout.y;
}
if (legend.layout && legend.layout.width) {
_getElementById("layoutWidth").value = legend.layout.width;
}
if (legend.layout && legend.layout.height) {
_getElementById("layoutHeight").value = legend.layout.height;
}
}
function applySetting() {
var sheet = spread.getActiveSheet();
var chart = getActiveChart(sheet);
if (!chart) {
return;
}
var legend = {
visible: _geBoolean("visible"),
position: _getValue("position"),
showLegendWithoutOverlapping: _geBoolean("showLegendWithoutOverlapping"),
backColor: _getText("backColor"),
backColorTransparency: _getFloat("backColorTransparency"),
color: _getText("color"),
fontFamily: _getText("fontFamily"),
fontSize: _getValue("fontSize"),
borderStyle:{
color: _getText("border-color"),
width: _getValue("border-width"),
transparency: _getFloat("border-transparency")
},
layout: {
x: _getFloat("layoutX"),
y: _getFloat("layoutY"),
width: _getFloat("layoutWidth"),
height: _getFloat("layoutHeight")
}
}
chart.legend(legend);
}
function getActiveChart(sheet) {
var activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
function _getElementById(id) {
return document.getElementById(id);
}
function _geBoolean(id) {
return _getElementById(id).checked;
}
function _getFloat(id) {
return isNaN(parseFloat(_getElementById(id).value)) ? undefined : parseFloat(_getElementById(id).value);
}
function _getValue(id) {
return parseInt(_getElementById(id).value);
}
function _getText(id) {
return _getElementById(id).value;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-charts/dist/gc.spread.sheets.charts.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>Change the properties below then press the Set button to apply these changes.</p>
<div class="option-row">
<label for="visible">Visible</label>
<input type="checkbox" id="visible" checked />
</div>
<div class="option-row" id="">
<label for="position">Position</label>
<select id="position">
<option value="1">top</option>
<option value="2">right</option>
<option value="3">left</option>
<option value="4" selected="selected">bottom</option>
<option value="5">topRight</option>
</select>
</div>
<div class="option-row">
<input type="checkbox" id="showLegendWithoutOverlapping" checked />
<label style="display:inline" for="showLegendWithoutOverlapping">Show the legend without overlapping the chart</label>
</div>
<div class="option-row" id="">
<label for="backColor">Back Color</label>
<input type="text" id="backColor" value="#FF0000" />
</div>
<div class="option-row" id="">
<label for="backColorTransparency">Back Color Transparency</label>
<input type="number" id="backColorTransparency" step="0.1" min="0" max="1" value="0.7" />
</div>
<hr>
<div class="option-row">
<label for="layoutX">Legend X(% of Chart)</label>
<input type="number" id="layoutX" step="0.01" min="0" max="1" />
</div>
<div class="option-row">
<label for="layoutY">Legend Y(% of Chart)</label>
<input type="number" id="layoutY" step="0.01" min="0" max="1" />
</div>
<div class="option-row">
<label for="layoutWidth">Legend Width(% of Chart)</label>
<input type="number" id="layoutWidth" step="0.01" min="0" max="1" />
</div>
<div class="option-row">
<label for="layoutHeight">Legend Height(% of Chart)</label>
<input type="number" id="layoutHeight" step="0.01" min="0" max="1" />
</div>
<hr>
<div class="option-row" id="">
<label for="color">Font Color:</label>
<input type="text" id="color" value="#00FF00" />
</div>
<div class="option-row" id="">
<label for="fontFamily">Font Family:</label>
<input type="text" id="fontFamily" value="Calibri" />
</div>
<div class="option-row" id="">
<label for="fontSize">Font Size:</label>
<input type="number" id="fontSize" step="1" min="0" max="100" value="1" />
</div>
<hr>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value="#00FF00" />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value="1" />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value="1" />
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" />
</div>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

The chart legend supports the following customization:
Visible: the legend visibility.
Position: top, right, left, bottom, topRight.
Background: color, transparency.
Text: font family, font size, color.
Border: color, transparency, width.
Overlapping: whether the legend display with overlapping plotArea.
Layout: x, y, width, height.
You can customize the legend using the following code:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
function _getBoolean(e) {
return e.target.checked;
}
function _getFloat(e) {
return parseFloat(e.target.value);
}
function _getValue(e) {
return parseInt(e.target.value);
}
function _getText(e) {
return e.target.value;
}
let spread = null;
export function AppFunc() {
const [legendOption, setLegendOption] = React.useState({
visible: true,
position: '4',
showLegendWithoutOverlapping: true,
backColor: '#FF0000',
backColorTransparency: '0.7',
color: '#00FF00',
fontFamily: 'Calibri',
fontSize: 1,
borderColor: '#00FF00',
borderWidth: 1,
borderTransparency: 1,
layoutX: undefined,
layoutY: undefined,
layoutWidth: undefined,
layoutHeight: undefined
});
const initSpread = (currSpread) => {
spread = currSpread;
spread.setSheetCount(2);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 30, 120, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({ text: "Chart Legend" });
let legend = chart.legend();
legend.borderStyle.color = "green";
legend.borderStyle.width = 3;
legend.fontSize = 9;
legend.backColor = "orange";
legend.backColorTransparency = 0.8;
chart.legend(legend);
sheet.resumePaint();
// readSetting(chart);
initEvent();
};
const initEvent = () => {
spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
let sheet = spread.getActiveSheet();
let chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
};
const readSetting = (chart) => {
let legend = chart.legend();
let legendLayout = legend.layout;
let layout = {};
if (legendLayout) {
layout["x"] = legendLayout.x * 100;
layout["y"] = legendLayout.y * 100;
layout["width"] = legendLayout.width * 100;
layout["height"] = legendLayout.height * 100;
}
else {
layout["x"] = undefined;
layout["y"] = undefined;
layout["width"] = undefined;
layout["height"] = undefined;
}
setLegendOption({
...legendOption,
visible: legend.visible,
position: legend.position,
showLegendWithoutOverlapping: legend.showLegendWithoutOverlapping !== false,
backColor: legend.backColor,
backColorTransparency: legend.backColorTransparency,
color: legend.color,
fontFamily: legend.fontFamily,
fontSize: legend.fontSize,
borderColor: legend.borderStyle.color,
borderWidth: legend.borderStyle.width,
borderTransparency: legend.borderStyle.transparency,
layoutX: layout.x,
layoutY: layout.y,
layoutWidth: layout.width,
layout: layout.height,
})
}
const applySetting = (setting) => {
let sheet = spread.getActiveSheet();
let chart = getActiveChart(sheet);
if (!chart) {
return;
}
let legend = {
visible: setting.visible,
position: setting.position,
showLegendWithoutOverlapping: setting.showLegendWithoutOverlapping,
backColor: setting.backColor,
backColorTransparency: setting.backColorTransparency,
color: setting.color,
fontFamily: setting.fontFamily,
fontSize: setting.fontSize,
borderStyle: {
color: setting.borderColor,
width: setting.borderWidth,
transparency: setting.borderTransparency,
},
layout: {
x: setting.layoutX && setting.layoutX,
y: setting.layoutY && setting.layoutY,
width: setting.layoutWidth && setting.layoutWidth,
height: setting.layoutHeight && setting.layoutHeight
}
}
chart.legend(legend);
}
const getActiveChart = (sheet) => {
let activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet />
</SpreadSheets>
</div>
<Panel applySetting={(e) => { applySetting(e) }} setting={legendOption} />
</div>);
}
function Panel(props) {
const [setting, setSetting] = React.useState(props.setting);
React.useEffect(() => {
if (setSetting !== props.setting) {
setSetting(props.setting);
}
}, [props.setting]);
return (
<div class="options-container">
<p>Change the properties below then press the Set button to apply these changes.</p>
<div class="option-row">
<label for="visible">Visible</label>
<input type="checkbox" id="visible" checked={setting.visible} onClick={(e) => setSetting({ ...setting, visible: _getBoolean(e) })} />
</div>
<div class="option-row" id="">
<label for="position">Position</label>
<select id="position" value={setting.position} onChange={(e) => setSetting({ ...setting, position: _getValue(e) })}>
<option value="1">top</option>
<option value="2">right</option>
<option value="3">left</option>
<option value="4" selected="selected">bottom</option>
<option value="5">topRight</option>
</select>
</div>
<div class="option-row">
<input type="checkbox" id="showLegendWithoutOverlapping" checked={setting.showLegendWithoutOverlapping} onClick={(e) => setSetting({ ...setting, showLegendWithoutOverlapping: _getBoolean(e) })} />
<label style={{ display: 'inline' }} for="showLegendWithoutOverlapping">Show the legend without overlapping the chart</label>
</div>
<div class="option-row" id="">
<label for="backColor">Back Color</label>
<input type="text" id="backColor" value={setting.backColor} onChange={(e) => setSetting({ ...setting, backColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="backColorTransparency">Back Color Transparency</label>
<input type="number" id="backColorTransparency" step="0.1" min="0" max="1" value={setting.backColorTransparency} onChange={(e) => setSetting({ ...setting, backColorTransparency: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutX">Legend X(% of Chart)</label>
<input type="number" id="layoutX" step="0.01" min="0" max="1" value={setting.layoutX} onChange={(e) => setSetting({ ...setting, layoutX: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutY">Legend Y(% of Chart)</label>
<input type="number" id="layoutY" step="0.01" min="0" max="1" value={setting.layoutY} onChange={(e) => setSetting({ ...setting, layoutY: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutWidth">Legend Width(% of Chart)</label>
<input type="number" id="layoutWidth" step="0.01" min="0" max="1" value={setting.layoutWidth} onChange={(e) => setSetting({ ...setting, layoutWidth: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutHeight">Legend Height(% of Chart)</label>
<input type="number" id="layoutHeight" step="0.01" min="0" max="1" value={setting.layoutHeight} onChange={(e) => setSetting({ ...setting, layoutHeight: _getFloat(e) })} />
</div>
<hr />
<div class="option-row" id="">
<label for="color">Font Color:</label>
<input type="text" id="color" value={setting.color} onChange={(e) => setSetting({ ...setting, color: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="fontFamily">Font Family:</label>
<input type="text" id="fontFamily" value={setting.fontFamily} onChange={(e) => setSetting({ ...setting, fontFamily: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="fontSize">Font Size:</label>
<input type="number" id="fontSize" step="1" min="0" max="100" value={setting.fontSize} onChange={(e) => setSetting({ ...setting, fontSize: _getValue(e) })} />
</div>
<hr />
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value={setting.borderColor} onChange={(e) => setSetting({ ...setting, borderColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value={setting.borderWidth} onChange={(e) => setSetting({ ...setting, borderWidth: _getValue(e) })} />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value={setting.borderTransparency} onChange={(e) => setSetting({ ...setting, borderTransparency: _getFloat(e) })} />
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" onClick={(e) => { props.applySetting(setting) }} />
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
const Component = React.Component;
function _getBoolean(e) {
return e.target.checked;
}
function _getFloat(e) {
return parseFloat(e.target.value);
}
function _getValue(e) {
return parseInt(e.target.value);
}
function _getText(e) {
return e.target.value;
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
visible: true,
position: '4',
showLegendWithoutOverlapping: true,
backColor: '#FF0000',
backColorTransparency: '0.7',
color: '#00FF00',
fontFamily: 'Calibri',
fontSize: 1,
borderColor: '#00FF00',
borderWidth: 1,
borderTransparency: 1,
layoutX: undefined,
layoutY: undefined,
layoutWidth: undefined,
layoutHeight: undefined
}
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet />
</SpreadSheets>
</div>
<Panel applySetting={(e) => { this.applySetting(e) }} setting={this.state} />
</div>);
}
initSpread(spread) {
this.spread = spread;
spread.setSheetCount(2);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 30, 120, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({ text: "Chart Legend" });
let legend = chart.legend();
legend.borderStyle.color = "green";
legend.borderStyle.width = 3;
legend.fontSize = 9;
legend.backColor = "orange";
legend.backColorTransparency = 0.8;
chart.legend(legend);
sheet.resumePaint();
// this.readSetting(chart);
this.initEvent();
};
initEvent() {
let self = this;
self.spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
let sheet = self.spread.getActiveSheet();
let chart = self.getActiveChart(sheet);
if (chart) {
self.readSetting(chart);
}
});
};
readSetting(chart) {
let legend = chart.legend();
let legendLayout = legend.layout;
let layout = {};
if (legendLayout) {
layout["x"] = legendLayout.x * 100;
layout["y"] = legendLayout.y * 100;
layout["width"] = legendLayout.width * 100;
layout["height"] = legendLayout.height * 100;
}
else {
layout["x"] = undefined;
layout["y"] = undefined;
layout["width"] = undefined;
layout["height"] = undefined;
}
this.setState({
visible: legend.visible,
position: legend.position,
showLegendWithoutOverlapping: legend.showLegendWithoutOverlapping !== false,
backColor: legend.backColor,
backColorTransparency: legend.backColorTransparency,
color: legend.color,
fontFamily: legend.fontFamily,
fontSize: legend.fontSize,
borderColor: legend.borderStyle.color,
borderWidth: legend.borderStyle.width,
borderTransparency: legend.borderStyle.transparency,
layoutX: layout.x,
layoutY: layout.y,
layoutWidth: layout.width,
layout: layout.height,
})
}
applySetting(setting) {
let sheet = this.spread.getActiveSheet();
let chart = this.getActiveChart(sheet);
if (!chart) {
return;
}
let legend = {
visible: setting.visible,
position: setting.position,
showLegendWithoutOverlapping: setting.showLegendWithoutOverlapping,
backColor: setting.backColor,
backColorTransparency: setting.backColorTransparency,
color: setting.color,
fontFamily: setting.fontFamily,
fontSize: setting.fontSize,
borderStyle: {
color: setting.borderColor,
width: setting.borderWidth,
transparency: setting.borderTransparency,
},
layout: {
x: setting.layoutX && setting.layoutX,
y: setting.layoutY && setting.layoutY,
width: setting.layoutWidth && setting.layoutWidth,
height: setting.layoutHeight && setting.layoutHeight
}
}
chart.legend(legend);
}
getActiveChart(sheet) {
let activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
}
class Panel extends Component {
constructor(props) {
super(props);
this.state = this.props.setting;
}
componentWillReceiveProps(nextProps) {
this.setState(nextProps.setting);
}
render() {
return (
<div class="options-container">
<p>Change the properties below then press the Set button to apply these changes.</p>
<div class="option-row">
<label for="visible">Visible</label>
<input type="checkbox" id="visible" checked={this.state.visible} onClick={(e) => this.setState({ visible: _getBoolean(e) })} />
</div>
<div class="option-row" id="">
<label for="position">Position</label>
<select id="position" value={this.state.position} onChange={(e) => this.setState({ position: _getValue(e) })}>
<option value="1">top</option>
<option value="2">right</option>
<option value="3">left</option>
<option value="4" selected="selected">bottom</option>
<option value="5">topRight</option>
</select>
</div>
<div class="option-row">
<input type="checkbox" id="showLegendWithoutOverlapping" checked={this.state.showLegendWithoutOverlapping} onClick={(e) => this.setState({ showLegendWithoutOverlapping: _getBoolean(e) })} />
<label style={{ display: 'inline' }} for="showLegendWithoutOverlapping">Show the legend without overlapping the chart</label>
</div>
<div class="option-row" id="">
<label for="backColor">Back Color</label>
<input type="text" id="backColor" value={this.state.backColor} onChange={(e) => this.setState({ backColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="backColorTransparency">Back Color Transparency</label>
<input type="number" id="backColorTransparency" step="0.1" min="0" max="1" value={this.state.backColorTransparency} onChange={(e) => this.setState({ backColorTransparency: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutX">Legend X(% of Chart)</label>
<input type="number" id="layoutX" step="0.01" min="0" max="1" value={this.state.layoutX} onChange={(e) => this.setState({ layoutX: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutY">Legend Y(% of Chart)</label>
<input type="number" id="layoutY" step="0.01" min="0" max="1" value={this.state.layoutY} onChange={(e) => this.setState({ layoutY: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutWidth">Legend Width(% of Chart)</label>
<input type="number" id="layoutWidth" step="0.01" min="0" max="1" value={this.state.layoutWidth} onChange={(e) => this.setState({ layoutWidth: _getFloat(e) })} />
</div>
<div class="option-row">
<label for="layoutHeight">Legend Height(% of Chart)</label>
<input type="number" id="layoutHeight" step="0.01" min="0" max="1" value={this.state.layoutHeight} onChange={(e) => this.setState({ layoutHeight: _getFloat(e) })} />
</div>
<hr />
<div class="option-row" id="">
<label for="color">Font Color:</label>
<input type="text" id="color" value={this.state.color} onChange={(e) => this.setState({ color: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="fontFamily">Font Family:</label>
<input type="text" id="fontFamily" value={this.state.fontFamily} onChange={(e) => this.setState({ fontFamily: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="fontSize">Font Size:</label>
<input type="number" id="fontSize" step="1" min="0" max="100" value={this.state.fontSize} onChange={(e) => this.setState({ fontSize: _getValue(e) })} />
</div>
<hr />
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value={this.state.borderColor} onChange={(e) => this.setState({ borderColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value={this.state.borderWidth} onChange={(e) => this.setState({ borderWidth: _getValue(e) })} />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value={this.state.borderTransparency} onChange={(e) => this.setState({ borderTransparency: _getFloat(e) })} />
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" onClick={(e) => { this.props.applySetting(this.state) }} />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

The chart legend supports the following customization:
Visible: the legend visibility.
Position: top, right, left, bottom, topRight.
Background: color, transparency.
Text: font family, font size, color.
Border: color, transparency, width.
Overlapping: whether the legend display with overlapping plotArea.
Layout: x, y, width, height.
You can customize the legend using the following code:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import '@mescius/spread-sheets-charts';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
visible = true;
position = '4';
backColor = '#FF0000';
backColorTransparency = '0.7';
color = '#00FF00';
fontFamily = 'Calibri';
fontSize = 1;
borderColor = '#00FF00';
borderWidth = 1;
borderTransparency = 1;
showLegendWithoutOverlapping = true;
layoutX: string;
layoutY: string;
layoutWidth: string;
layoutHeight: string;
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 30, 120, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({
text: "Chart Legend"
});
let legend = chart.legend();
legend.borderStyle.color = "green";
legend.borderStyle.width = 3;
legend.fontSize = 9;
legend.backColor = "orange";
legend.backColorTransparency = 0.8;
chart.legend(legend);
sheet.resumePaint();
// this.readSetting(chart);
this.initEvent(spread);
}
initEvent(spread: GC.Spread.Sheets.Workbook) {
spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, ()=>{
let sheet = spread.getActiveSheet();
let chart = this.getActiveChart(sheet);
if (chart) {
this.readSetting(chart);
};
}
);
}
readSetting(chart: GC.Spread.Sheets.Charts.Chart) {
let legend = chart.legend();
this.visible = legend.visible;
this.position = legend.position;
this.backColor = legend.backColor;
this.backColorTransparency = legend.backColorTransparency;
this.color = legend.color;
this.fontFamily = legend.fontFamily;
this.fontSize = legend.fontSize;
this.borderColor = legend.borderStyle.color;
this.borderWidth = legend.borderStyle.width;
this.borderTransparency = legend.borderStyle.transparency;
this.showLegendWithoutOverlapping = legend.showLegendWithoutOverlapping !== false;
if (legend.layout && legend.layout.x) {
this.layoutX = legend.layout.x;
}
if (legend.layout && legend.layout.y) {
this.layoutY = legend.layout.y;
}
if (legend.layout && legend.layout.width) {
this.layoutWidth = legend.layout.width;
}
if (legend.layout && legend.layout.height) {
this.layoutHeight = legend.layout.height;
}
}
applySetting() {
let sheet = this.spread.getActiveSheet();
let chart = this.getActiveChart(sheet);
if (!chart) {
return;
}
let legend = {
visible: this.visible,
position: parseInt(this.position),
backColor: this.backColor,
backColorTransparency: parseFloat(<any>this.backColorTransparency),
showLegendWithoutOverlapping: Boolean(this.showLegendWithoutOverlapping),
color: this.color,
fontFamily: this.fontFamily,
fontSize: parseInt(<any>this.fontSize),
borderStyle: {
color: this.borderColor,
width: parseInt(<any>this.borderWidth),
transparency: parseFloat(<any>this.borderTransparency),
},
layout:{
x: this.layoutX,
y: this.layoutY,
width: this.layoutWidth,
height: this.layoutHeight
}
}
chart.legend(legend);
}
getActiveChart(sheet: GC.Spread.Sheets.Worksheet): GC.Spread.Sheets.Charts.Chart | null {
let activeChart = null;
sheet.charts.all().forEach(function(chart: GC.Spread.Sheets.Charts.Chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>Change the properties below then press the Set button to apply these changes.</p>
<div class="option-row" id="">
<label for="visible">Visible</label>
<input type="checkbox" id="visible" [(ngModel)] = "visible" />
</div>
<div class="option-row" id="">
<label for="position">Position</label>
<select id="position" [(ngModel)]="position">
<option value="1">top</option>
<option value="2">right</option>
<option value="3">left</option>
<option value="4" >bottom</option>
<option value="5">topRight</option>
</select>
</div>
<div class="option-row">
<input type="checkbox" id="showLegendWithoutOverlapping" [(ngModel)] = "showLegendWithoutOverlapping" />
<label style="display:inline" for="showLegendWithoutOverlapping">Show the legend without overlapping the chart</label>
</div>
<div class="option-row" id="">
<label for="backColor">Back Color</label>
<input type="text" id="backColor" [(ngModel)]="backColor" />
</div>
<div class="option-row" id="">
<label for="backColorTransparency">Back Color Transparency</label>
<input type="number" id="backColorTransparency" step="0.1" min="0" max="1" [(ngModel)]="backColorTransparency" />
</div>
<div class="option-row">
<label for="layoutX">Legend X(% of Chart)</label>
<input type="number" id="layoutX" step="0.01" min="0" max="1" [(ngModel)]="layoutX"/>
</div>
<div class="option-row">
<label for="layoutY">Legend Y(% of Chart)</label>
<input type="number" id="layoutY" step="0.01" min="0" max="1" [(ngModel)]="layoutY"/>
</div>
<div class="option-row">
<label for="layoutWidth">Legend Width(% of Chart)</label>
<input type="number" id="layoutWidth" step="0.01" min="0" max="1" [(ngModel)]="layoutWidth"/>
</div>
<div class="option-row">
<label for="layoutHeight">Legend Height(% of Chart)</label>
<input type="number" id="layoutHeight" step="0.01" min="0" max="1" [(ngModel)]="layoutHeight"/>
</div>
<hr>
<div class="option-row" id="">
<label for="color">Font Color:</label>
<input type="text" id="color" [(ngModel)]="color"/>
</div>
<div class="option-row" id="">
<label for="fontFamily">Font Family</label>
<input type="text" id="fontFamily" [(ngModel)]="fontFamily" />
</div>
<div class="option-row" id="">
<label for="fontSize">Font Size</label>
<input type="number" id="fontSize" step="1" min="0" max="100" [(ngModel)]="fontSize" />
</div>
<hr>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" [(ngModel)]="borderColor" />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" [(ngModel)]="borderTransparency" />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" [(ngModel)]="borderWidth" />
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" (click)="applySetting()" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

The chart legend supports the following customization:
Visible: the legend visibility.
Position: top, right, left, bottom, topRight.
Background: color, transparency.
Text: font family, font size, color.
Border: color, transparency, width.
Overlapping: whether the legend display with overlapping plotArea.
Layout: x, y, width, height.
You can customize the legend using the following code:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet />
</gc-spread-sheets>
<div class="options-container">
<p>Change the properties below then press the Set button to apply these changes.</p>
<div class="option-row">
<label for="visible">Visible</label>
<input type="checkbox" id="visible" v-model="visible" />
</div>
<div class="option-row" id>
<label for="position">Position</label>
<select id="position" v-model="position">
<option value="1">top</option>
<option value="2">right</option>
<option value="3">left</option>
<option value="4">bottom</option>
<option value="5">topRight</option>
</select>
</div>
<div class="option-row">
<input type="checkbox" id="showLegendWithoutOverlapping" v-model="showLegendWithoutOverlapping" />
<label style="display:inline" for="showLegendWithoutOverlapping">Show the legend without overlapping the
chart</label>
</div>
<div class="option-row" id>
<label for="backColor">Back Color</label>
<input type="text" id="backColor" v-model="backColor" />
</div>
<div class="option-row" id>
<label for="backColorTransparency">Back Color Transparency</label>
<input type="number" id="backColorTransparency" step="0.1" min="0" max="1"
v-model="backColorTransparency" />
</div>
<div class="option-row">
<label for="layoutX">Legend X(% of Chart)</label>
<input type="number" id="layoutX" step="0.01" min="0" max="1" v-model="layoutX" />
</div>
<div class="option-row">
<label for="layoutY">Legend Y(% of Chart)</label>
<input type="number" id="layoutY" step="0.01" min="0" max="1" v-model="layoutY" />
</div>
<div class="option-row">
<label for="layoutWidth">Legend Width(% of Chart)</label>
<input type="number" id="layoutWidth" step="0.01" min="0" max="1" v-model="layoutWidth" />
</div>
<div class="option-row">
<label for="layoutHeight">Legend Height(% of Chart)</label>
<input type="number" id="layoutHeight" step="0.01" min="0" max="1" v-model="layoutHeight" />
</div>
<hr />
<div class="option-row" id>
<label for="fontFamily">Font Family</label>
<input type="text" id="fontFamily" v-model="fontFamily" />
</div>
<div class="option-row" id>
<label for="fontSize">Font Size</label>
<input type="number" id="fontSize" step="1" min="0" max="100" v-model="fontSize" />
</div>
<div class="option-row" id>
<label for="color">Color</label>
<input type="text" id="color" v-model="color" />
</div>
<div class="option-row" id>
<label for="transparency">Transparency</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" v-model="transparency" />
</div>
<hr />
<div class="option-row" id>
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" v-model="borderColor" />
</div>
<div class="option-row" id>
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" v-model="borderTransparency" />
</div>
<div class="option-row" id>
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" v-model="borderWidth" />
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" @click="applySetting" />
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
const spread = ref(null);
const visible = ref(true);
const position = ref('4');
const showLegendWithoutOverlapping = ref(true);
const layoutX = ref(undefined);
const layoutY = ref(undefined);
const layoutWidth = ref(undefined);
const layoutHeight = ref(undefined);
const backColor = ref('#FF0000');
const backColorTransparency = ref('0.7');
const color = ref('#00FF00');
const transparency = ref(1);
const fontFamily = ref('Calibri');
const fontSize = ref(1);
const borderColor = ref('#00FF00');
const borderWidth = ref(1);
const borderTransparency = ref(1);
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
spreadInstance.setSheetCount(2);
const sheet = spreadInstance.getSheet(0);
sheet.suspendPaint();
const dataArray = [
['', 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
['2014', 0.4966, 0.1801, 0.2455, 0.047, 0.0, 0.015, 0.0158],
['2015', 0.5689, 0.156, 0.1652, 0.0529, 0.0158, 0.022, 0.0192],
['2016', 0.623, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
['2017', 0.636, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246],
];
sheet.setArray(0, 0, dataArray);
const chart = sheet.charts.add(
'Chart1',
GC.Spread.Sheets.Charts.ChartType.lineMarkers,
30,
120,
480,
270,
'A1:D5',
GC.Spread.Sheets.Charts.RowCol.columns,
);
chart.title({
text: 'Chart Legend',
});
const legend = chart.legend();
legend.borderStyle.color = 'green';
legend.borderStyle.width = 3;
legend.fontSize = 9;
legend.backColor = 'orange';
legend.backColorTransparency = 0.8;
chart.legend(legend);
sheet.resumePaint();
initEvent();
};
const initEvent = () => {
spread.value.bind(GC.Spread.Sheets.Events.FloatingElementSelected, () => {
const sheet = spread.value.getActiveSheet();
const chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
};
const readSetting = (chart) => {
const legend = chart.legend();
visible.value = legend.visible;
position.value = legend.position;
showLegendWithoutOverlapping.value = legend.showLegendWithoutOverlapping !== false;
backColor.value = legend.backColor;
backColorTransparency.value = legend.backColorTransparency;
color.value = legend.color;
fontFamily.value = legend.fontFamily;
fontSize.value = legend.fontSize;
borderColor.value = legend.borderStyle.color;
borderWidth.value = legend.borderStyle.width;
borderTransparency.value = legend.borderStyle.transparency;
if (legend.layout && legend.layout.x) {
layoutX.value = legend.layout.x;
}
if (legend.layout && legend.layout.y) {
layoutY.value = legend.layout.y;
}
if (legend.layout && legend.layout.width) {
layoutWidth.value = legend.layout.width;
}
if (legend.layout && legend.layout.height) {
layoutHeight.value = legend.layout.height;
}
};
const applySetting = () => {
const sheet = spread.value.getActiveSheet();
const chart = getActiveChart(sheet);
if (!chart) return;
const legend = {
visible: visible.value,
position: parseInt(position.value, 10),
showLegendWithoutOverlapping: Boolean(showLegendWithoutOverlapping.value),
backColor: backColor.value,
backColorTransparency: Number(backColorTransparency.value),
color: color.value,
fontFamily: fontFamily.value,
fontSize: parseInt(fontSize.value, 10),
borderStyle: {
color: borderColor.value,
width: parseInt(borderWidth.value, 10),
transparency: Number(borderTransparency.value),
},
layout: {
x: layoutX.value !== undefined ? Number(layoutX.value) : undefined,
y: layoutY.value !== undefined ? Number(layoutY.value) : undefined,
width: layoutWidth.value !== undefined ? Number(layoutWidth.value) : undefined,
height: layoutHeight.value !== undefined ? Number(layoutHeight.value) : undefined,
},
};
chart.legend(legend);
};
const getActiveChart = (sheet) => {
let activeChart = null;
sheet.charts.all().forEach((chart) => {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
};
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display: inline-block;
}
input {
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select {
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);